diff --git a/src/charts/chartpresenter2.cpp b/src/charts/chartpresenter2.cpp
index 813d5855..99326420 100644
--- a/src/charts/chartpresenter2.cpp
+++ b/src/charts/chartpresenter2.cpp
@@ -38,7 +38,7 @@
 #include <private/qabstractseries_p.h>
 #include <QtCharts/QAreaSeries>
 #include <private/chartaxiselement_p.h>
-#include <private/chartbackground_p.h>
+#include "chartbackground2_p.h"
 #include "cartesianchartlayout2_p.h"
 #include "polarchartlayout2_p.h"
 #include <private/charttitle_p.h>
@@ -47,6 +47,10 @@
 #include <QtGui/QTextDocument>
 #include <QtWidgets/QGraphicsScene>
 #include <QtWidgets/QGraphicsView>
+#include <QQuickItem>
+#include <QQuickPaintedItem>
+#include <private/abstractdomain_p.h>
+#include "charttitle2_p.h"
 
 QT_CHARTS_BEGIN_NAMESPACE
 
@@ -66,11 +70,12 @@ ChartPresenter2::ChartPresenter2(QChart2 *chart, QChart::ChartType type)
       , m_glUseWidget(true)
 #endif
 {
-    if (type == QChart::ChartTypeCartesian)
-        m_layout = new CartesianChartLayout2(this);
-    else if (type == QChart::ChartTypePolar)
-        m_layout = new PolarChartLayout2(this);
-    Q_ASSERT(m_layout);
+//    TODO
+//    if (type == QChart::ChartTypeCartesian)
+//        m_layout = new CartesianChartLayout2(this);
+//    else if (type == QChart::ChartTypePolar)
+//        m_layout = new PolarChartLayout2(this);
+//    Q_ASSERT(m_layout);
 }
 
 ChartPresenter2::~ChartPresenter2()
@@ -90,7 +95,7 @@ void ChartPresenter2::setFixedGeometry(const QRectF &rect)
         // Update to the latest geometry properly if changed
         if (!isSame) {
             updateGeometry(m_rect);
-            m_layout->updateGeometry();
+//            m_layout->updateGeometry();
         }
     } else {
         updateGeometry(m_fixedRect);
@@ -111,7 +116,7 @@ void ChartPresenter2::updateGeometry(const QRectF &rect)
 {
     foreach (ChartItem2 *chart, m_chartItems) {
         chart->domain()->setSize(rect.size());
-        chart->setPos(rect.topLeft());
+//        chart->setPos(rect.topLeft());
     }
 #ifndef QT_NO_OPENGL
     if (!m_glWidget.isNull())
@@ -134,7 +139,7 @@ void ChartPresenter2::handleAxisAdded(QAbstractAxis *axis)
     item->setThemeManager(m_chart->d_ptr->m_themeManager);
     m_axisItems<<item;
     m_axes<<axis;
-    m_layout->invalidate();
+//    m_layout->invalidate();
 }
 
 void ChartPresenter2::handleAxisRemoved(QAbstractAxis *axis)
@@ -142,12 +147,14 @@ void ChartPresenter2::handleAxisRemoved(QAbstractAxis *axis)
     ChartAxisElement2 *item = axis->d_ptr->m_item2.take();
     if (item->animation())
         item->animation()->stopAndDestroyLater();
-    item->hide();
+
+    // TODO
+    item->setVisible(false);//->hide();
     item->disconnect();
     item->deleteLater();
     m_axisItems.removeAll(item);
     m_axes.removeAll(axis);
-    m_layout->invalidate();
+//    m_layout->invalidate();
 }
 
 
@@ -161,17 +168,17 @@ void ChartPresenter2::handleSeriesAdded(QAbstractSeries *series)
     chart->setThemeManager(m_chart->d_ptr->m_themeManager);
     chart->setDataSet(m_chart->d_ptr->m_dataset);
     chart->domain()->setSize(geometry().size());
-    chart->setPos(geometry().topLeft());
+    chart->setPosition(geometry().topLeft());
     chart->handleDomainUpdated(); //this could be moved to intializeGraphics when animator is refactored
     m_chartItems<<chart;
     m_series<<series;
-    m_layout->invalidate();
+//    m_layout->invalidate();
 }
 
 void ChartPresenter2::handleSeriesRemoved(QAbstractSeries *series)
 {
     ChartItem2 *chart  = series->d_ptr->m_item2.take();
-    chart->hide();
+    chart->setVisible(false);
     chart->cleanup();
     series->disconnect(chart);
     chart->deleteLater();
@@ -179,7 +186,7 @@ void ChartPresenter2::handleSeriesRemoved(QAbstractSeries *series)
         chart->animation()->stopAndDestroyLater();
     m_chartItems.removeAll(chart);
     m_series.removeAll(series);
-    m_layout->invalidate();
+//    m_layout->invalidate();
 }
 
 void ChartPresenter2::setAnimationOptions(QChart::AnimationOptions options)
@@ -196,7 +203,7 @@ void ChartPresenter2::setAnimationOptions(QChart::AnimationOptions options)
             foreach (QAbstractAxis *axis, m_axes)
                 axis->d_ptr->initializeAnimations(m_options, m_animationDuration, m_animationCurve);
         }
-        m_layout->invalidate(); // So that existing animations don't just stop halfway
+//        m_layout->invalidate(); // So that existing animations don't just stop halfway
     }
 }
 
@@ -208,7 +215,7 @@ void ChartPresenter2::setAnimationDuration(int msecs)
             series->d_ptr->initializeAnimations(m_options, m_animationDuration, m_animationCurve);
         foreach (QAbstractAxis *axis, m_axes)
             axis->d_ptr->initializeAnimations(m_options, m_animationDuration, m_animationCurve);
-        m_layout->invalidate(); // So that existing animations don't just stop halfway
+//        m_layout->invalidate(); // So that existing animations don't just stop halfway
     }
 }
 
@@ -220,7 +227,7 @@ void ChartPresenter2::setAnimationEasingCurve(const QEasingCurve &curve)
             series->d_ptr->initializeAnimations(m_options, m_animationDuration, m_animationCurve);
         foreach (QAbstractAxis *axis, m_axes)
             axis->d_ptr->initializeAnimations(m_options, m_animationDuration, m_animationCurve);
-        m_layout->invalidate(); // So that existing animations don't just stop halfway
+//        m_layout->invalidate(); // So that existing animations don't just stop halfway
     }
 }
 
@@ -238,25 +245,25 @@ QChart::AnimationOptions ChartPresenter2::animationOptions() const
 void ChartPresenter2::createBackgroundItem()
 {
     if (!m_background) {
-        m_background = new ChartBackground(rootItem());
-        m_background->setPen(Qt::NoPen); // Theme doesn't touch pen so don't use default
-        m_background->setBrush(QChartPrivate::defaultBrush());
-        m_background->setZValue(ChartPresenter2::BackgroundZValue);
+        m_background = new ChartBackground2(rootItem());
+//        m_background->setPen(Qt::NoPen); // Theme doesn't touch pen so don't use default
+//        m_background->setBrush(QChartPrivate::defaultBrush());
+//        m_background->setZValue(ChartPresenter2::BackgroundZValue);
     }
 }
 
 void ChartPresenter2::createPlotAreaBackgroundItem()
 {
     if (!m_plotAreaBackground) {
-        if (m_chart->chartType() == QChart::ChartTypeCartesian)
-            m_plotAreaBackground = new QGraphicsRectItem(rootItem());
-        else
-            m_plotAreaBackground = new QGraphicsEllipseItem(rootItem());
+//        if (m_chart->chartType() == QChart::ChartTypeCartesian)
+            m_plotAreaBackground = new QQuickItem(rootItem());
+//        else
+//            m_plotAreaBackground = new QGraphicsEllipseItem(rootItem());
         // Use transparent pen instead of Qt::NoPen, as Qt::NoPen causes
         // antialising artifacts with axis lines for some reason.
-        m_plotAreaBackground->setPen(QPen(Qt::transparent));
-        m_plotAreaBackground->setBrush(Qt::NoBrush);
-        m_plotAreaBackground->setZValue(ChartPresenter2::PlotAreaZValue);
+//        m_plotAreaBackground->setPen(QPen(Qt::transparent));
+//        m_plotAreaBackground->setBrush(Qt::NoBrush);
+//        m_plotAreaBackground->setZValue(ChartPresenter2::PlotAreaZValue);
         m_plotAreaBackground->setVisible(false);
     }
 }
@@ -264,8 +271,8 @@ void ChartPresenter2::createPlotAreaBackgroundItem()
 void ChartPresenter2::createTitleItem()
 {
     if (!m_title) {
-        m_title = new ChartTitle(rootItem());
-        m_title->setZValue(ChartPresenter2::BackgroundZValue);
+        m_title = new ChartTitle2(rootItem());
+//        m_title->setZValue(ChartPresenter2::BackgroundZValue);
     }
 }
 
@@ -278,36 +285,36 @@ void ChartPresenter2::startAnimation(ChartAnimation *animation)
 void ChartPresenter2::setBackgroundBrush(const QBrush &brush)
 {
     createBackgroundItem();
-    m_background->setBrush(brush);
-    m_layout->invalidate();
+//    m_background->setBrush(brush);
+//    m_layout->invalidate();
 }
 
 QBrush ChartPresenter2::backgroundBrush() const
 {
-    if (!m_background)
+//    if (!m_background)
         return QBrush();
-    return m_background->brush();
+//    return m_background->brush();
 }
 
 void ChartPresenter2::setBackgroundPen(const QPen &pen)
 {
     createBackgroundItem();
-    m_background->setPen(pen);
-    m_layout->invalidate();
+//    m_background->setPen(pen);
+//    m_layout->invalidate();
 }
 
 QPen ChartPresenter2::backgroundPen() const
 {
-    if (!m_background)
+//    if (!m_background)
         return QPen();
-    return m_background->pen();
+//    return m_background->pen();
 }
 
 void ChartPresenter2::setBackgroundRoundness(qreal diameter)
 {
     createBackgroundItem();
     m_background->setDiameter(diameter);
-    m_layout->invalidate();
+//    m_layout->invalidate();
 }
 
 qreal ChartPresenter2::backgroundRoundness() const
@@ -320,36 +327,36 @@ qreal ChartPresenter2::backgroundRoundness() const
 void ChartPresenter2::setPlotAreaBackgroundBrush(const QBrush &brush)
 {
     createPlotAreaBackgroundItem();
-    m_plotAreaBackground->setBrush(brush);
-    m_layout->invalidate();
+//    m_plotAreaBackground->setBrush(brush);
+//    m_layout->invalidate();
 }
 
 QBrush ChartPresenter2::plotAreaBackgroundBrush() const
 {
     if (!m_plotAreaBackground)
         return QBrush();
-    return m_plotAreaBackground->brush();
+//    return m_plotAreaBackground->brush();
 }
 
 void ChartPresenter2::setPlotAreaBackgroundPen(const QPen &pen)
 {
     createPlotAreaBackgroundItem();
-    m_plotAreaBackground->setPen(pen);
-    m_layout->invalidate();
+//    m_plotAreaBackground->setPen(pen);
+//    m_layout->invalidate();
 }
 
 QPen ChartPresenter2::plotAreaBackgroundPen() const
 {
     if (!m_plotAreaBackground)
         return QPen();
-    return m_plotAreaBackground->pen();
+//    return m_plotAreaBackground->pen();
 }
 
 void ChartPresenter2::setTitle(const QString &title)
 {
     createTitleItem();
     m_title->setText(title);
-    m_layout->invalidate();
+//    m_layout->invalidate();
 }
 
 QString ChartPresenter2::title() const
@@ -362,29 +369,29 @@ QString ChartPresenter2::title() const
 void ChartPresenter2::setTitleFont(const QFont &font)
 {
     createTitleItem();
-    m_title->setFont(font);
-    m_layout->invalidate();
+//    m_title->setFont(font);
+//    m_layout->invalidate();
 }
 
 QFont ChartPresenter2::titleFont() const
 {
-    if (!m_title)
+//    if (!m_title)
         return QFont();
-    return m_title->font();
+//    return m_title->font();
 }
 
 void ChartPresenter2::setTitleBrush(const QBrush &brush)
 {
     createTitleItem();
-    m_title->setDefaultTextColor(brush.color());
-    m_layout->invalidate();
+//    m_title->setDefaultTextColor(brush.color());
+//    m_layout->invalidate();
 }
 
 QBrush ChartPresenter2::titleBrush() const
 {
-    if (!m_title)
+//    if (!m_title)
         return QBrush();
-    return QBrush(m_title->defaultTextColor());
+//    return QBrush(m_title->defaultTextColor());
 }
 
 void ChartPresenter2::setBackgroundVisible(bool visible)
@@ -430,13 +437,13 @@ bool ChartPresenter2::isBackgroundDropShadowEnabled() const
 void ChartPresenter2::setLocalizeNumbers(bool localize)
 {
     m_localizeNumbers = localize;
-    m_layout->invalidate();
+//    m_layout->invalidate();
 }
 
 void ChartPresenter2::setLocale(const QLocale &locale)
 {
     m_locale = locale;
-    m_layout->invalidate();
+//    m_layout->invalidate();
 }
 
 AbstractChartLayout2 *ChartPresenter2::layout()
@@ -454,12 +461,12 @@ void ChartPresenter2::setVisible(bool visible)
     m_chart->setVisible(visible);
 }
 
-ChartBackground *ChartPresenter2::backgroundElement()
+ChartBackground2 *ChartPresenter2::backgroundElement()
 {
     return m_background;
 }
 
-QAbstractGraphicsShapeItem *ChartPresenter2::plotAreaElement()
+QQuickItem *ChartPresenter2::plotAreaElement()
 {
     return m_plotAreaBackground;
 }
@@ -474,7 +481,7 @@ QList<ChartItem2 *> ChartPresenter2::chartItems() const
     return m_chartItems;
 }
 
-ChartTitle *ChartPresenter2::titleElement()
+ChartTitle2 *ChartPresenter2::titleElement()
 {
     return m_title;
 }
@@ -586,30 +593,31 @@ QString ChartPresenter2::numberToString(int value)
 
 void ChartPresenter2::updateGLWidget()
 {
-#ifndef QT_NO_OPENGL
-    // GLWidget pointer is wrapped in QPointer as its parent is not in our control, and therefore
-    // can potentially get deleted unexpectedly.
-    if (!m_glWidget.isNull() && m_glWidget->needsReset()) {
-        m_glWidget->hide();
-        delete m_glWidget.data();
-        m_glWidget.clear();
-    }
-    if (m_glWidget.isNull() && m_glUseWidget && m_chart->scene()) {
-        // Find the view of the scene. If the scene has multiple views, only the first view is
-        // chosen.
-        QList<QGraphicsView *> views = m_chart->scene()->views();
-        if (views.size()) {
-            QGraphicsView *firstView = views.at(0);
-            m_glWidget = new GLWidget(m_chart->d_ptr->m_dataset->glXYSeriesDataManager(),
-                                      m_chart, firstView);
-            m_glWidget->setGeometry(geometry().toRect());
-            m_glWidget->show();
-        }
-    }
-    // Make sure we update the widget in a timely manner
-    if (!m_glWidget.isNull())
-        m_glWidget->update();
-#endif
+    // TODO!!
+//#ifndef QT_NO_OPENGL
+//    // GLWidget pointer is wrapped in QPointer as its parent is not in our control, and therefore
+//    // can potentially get deleted unexpectedly.
+//    if (!m_glWidget.isNull() && m_glWidget->needsReset()) {
+//        m_glWidget->hide();
+//        delete m_glWidget.data();
+//        m_glWidget.clear();
+//    }
+//    if (m_glWidget.isNull() && m_glUseWidget && m_chart->scene()) {
+//        // Find the view of the scene. If the scene has multiple views, only the first view is
+//        // chosen.
+//        QList<QGraphicsView *> views = m_chart->scene()->views();
+//        if (views.size()) {
+//            QGraphicsView *firstView = views.at(0);
+//            m_glWidget = new GLWidget(m_chart->d_ptr->m_dataset->glXYSeriesDataManager(),
+//                                      m_chart, firstView);
+//            m_glWidget->setGeometry(geometry().toRect());
+//            m_glWidget->show();
+//        }
+//    }
+//    // Make sure we update the widget in a timely manner
+//    if (!m_glWidget.isNull())
+//        m_glWidget->update();
+//#endif
 }
 
 QT_CHARTS_END_NAMESPACE
diff --git a/src/charts/chartpresenter2_p.h b/src/charts/chartpresenter2_p.h
index c15ead19..09cbd0f1 100644
--- a/src/charts/chartpresenter2_p.h
+++ b/src/charts/chartpresenter2_p.h
@@ -51,6 +51,8 @@
 #include <QtCore/QPointer>
 #include <QtCore/QEasingCurve>
 
+class QQuickPaintedItem;
+
 QT_CHARTS_BEGIN_NAMESPACE
 
 class ChartItem2;
@@ -60,8 +62,8 @@ class ChartDataSet2;
 class AbstractDomain;
 class ChartAxisElement2;
 class ChartAnimator;
-class ChartBackground;
-class ChartTitle;
+class ChartBackground2;
+class ChartTitle2;
 class ChartAnimation;
 class AbstractChartLayout2;
 
@@ -106,10 +108,10 @@ public:
     QRectF geometry() const;
     void updateGeometry(const QRectF &rect);
 
-    QGraphicsItem *rootItem(){ return m_chart; }
-    ChartBackground *backgroundElement();
-    QAbstractGraphicsShapeItem *plotAreaElement();
-    ChartTitle *titleElement();
+    QQuickItem *rootItem(){ return m_chart; }
+    ChartBackground2 *backgroundElement();
+    QQuickItem *plotAreaElement();
+    ChartTitle2 *titleElement();
     QList<ChartAxisElement2 *> axisItems() const;
     QList<ChartItem2 *> chartItems() const;
 
@@ -209,9 +211,10 @@ private:
     State m_state;
     QPointF m_statePoint;
     AbstractChartLayout2 *m_layout;
-    ChartBackground *m_background;
-    QAbstractGraphicsShapeItem *m_plotAreaBackground;
-    ChartTitle *m_title;
+    ChartBackground2 *m_background;
+    // TODO
+    QQuickItem *m_plotAreaBackground;
+    ChartTitle2 *m_title;
     QRectF m_rect;
     bool m_localizeNumbers;
     QLocale m_locale;
diff --git a/src/charts/charts.pro b/src/charts/charts.pro
index 80d62e2a..a6bcefdb 100644
--- a/src/charts/charts.pro
+++ b/src/charts/charts.pro
@@ -2,7 +2,7 @@
 
 TARGET = QtCharts
 
-QT = core gui widgets
+QT = core gui widgets quick quick-private
 contains(QT_COORD_TYPE, float): DEFINES += QT_QREAL_IS_FLOAT
 
 QMAKE_DOCS = $$PWD/doc/qtcharts.qdocconf
@@ -24,14 +24,17 @@ SOURCES += \
     $$PWD/qchartview.cpp \
     $$PWD/qabstractseries.cpp \
     $$PWD/chartbackground.cpp \
+    $$PWD/chartbackground2.cpp \
     $$PWD/chartelement2.cpp \
     $$PWD/chartelement.cpp \
     $$PWD/chartitem2.cpp \
     $$PWD/chartitem.cpp \
     $$PWD/scroller.cpp \
     $$PWD/charttitle.cpp \
+    $$PWD/charttitle2.cpp \
     $$PWD/qpolarchart.cpp \
-    $$PWD/qpolarchart2.cpp
+    $$PWD/qpolarchart2.cpp \
+    qchart3.cpp
 
 contains(QT_CONFIG, opengl): SOURCES += $$PWD/glwidget.cpp
 
@@ -43,6 +46,7 @@ PRIVATE_HEADERS += \
     $$PWD/chartpresenter_p.h \
     $$PWD/chartthememanager_p.h \
     $$PWD/chartbackground_p.h \
+    $$PWD/chartbackground2_p.h \
     $$PWD/chartelement_p.h \
     $$PWD/chartelement2_p.h \
     $$PWD/chartconfig_p.h \
@@ -52,6 +56,7 @@ PRIVATE_HEADERS += \
     $$PWD/scroller_p.h \
     $$PWD/qabstractseries_p.h \
     $$PWD/charttitle_p.h \
+    $$PWD/charttitle2_p.h \
     $$PWD/charthelpers_p.h \
     $$PWD/qchartglobal_p.h
 
@@ -83,7 +88,8 @@ include($$PWD/layout/layout.pri)
 include($$PWD/boxplotchart/boxplotchart.pri)
 include($$PWD/candlestickchart/candlestickchart.pri)
 
-HEADERS += $$PUBLIC_HEADERS
+HEADERS += $$PUBLIC_HEADERS \
+    qchart3.h
 HEADERS += $$PRIVATE_HEADERS
 HEADERS += $$THEMES
 
diff --git a/src/charts/layout/abstractchartlayout2.cpp b/src/charts/layout/abstractchartlayout2.cpp
index cf0852ca..ab979cdb 100644
--- a/src/charts/layout/abstractchartlayout2.cpp
+++ b/src/charts/layout/abstractchartlayout2.cpp
@@ -32,8 +32,9 @@
 #include <private/qlegend_p.h>
 #include <private/chartaxiselement_p.h>
 #include <private/charttitle_p.h>
-#include <private/chartbackground_p.h>
+#include <private/chartbackground2_p.h>
 #include <QtCore/QDebug>
+#include <charttitle2_p.h>
 #include "qlegend2_p.h"
 
 QT_CHARTS_BEGIN_NAMESPACE
@@ -58,9 +59,9 @@ void AbstractChartLayout2::setGeometry(const QRectF &rect)
     const bool updateLayout = (!m_presenter->isFixedGeometry() || m_presenter->geometry() == rect);
     if (m_presenter->chart()->isVisible()) {
         QList<ChartAxisElement2 *> axes = m_presenter->axisItems();
-        ChartTitle *title = m_presenter->titleElement();
+        ChartTitle2 *title = m_presenter->titleElement();
         QLegend2 *legend = m_presenter->legend();
-        ChartBackground *background = m_presenter->backgroundElement();
+        ChartBackground2 *background = m_presenter->backgroundElement();
 
         QRectF contentGeometry = calculateBackgroundGeometry(rect, background, updateLayout);
 
@@ -75,12 +76,12 @@ void AbstractChartLayout2::setGeometry(const QRectF &rect)
         contentGeometry = calculateAxisGeometry(contentGeometry, axes, updateLayout);
 
         m_presenter->setGeometry(contentGeometry);
-        if (updateLayout) {
-            if (m_presenter->chart()->chartType() == QChart::ChartTypeCartesian)
-                static_cast<QGraphicsRectItem *>(m_presenter->plotAreaElement())->setRect(contentGeometry);
-            else
-                static_cast<QGraphicsEllipseItem *>(m_presenter->plotAreaElement())->setRect(contentGeometry);
-        }
+//        if (updateLayout) {
+//            if (m_presenter->chart()->chartType() == QChart::ChartTypeCartesian)
+//                static_cast<QGraphicsRectItem *>(m_presenter->plotAreaElement())->setRect(contentGeometry);
+//            else
+//                static_cast<QGraphicsEllipseItem *>(m_presenter->plotAreaElement())->setRect(contentGeometry);
+//        }
     }
 
     QGraphicsLayout::setGeometry(rect);
@@ -98,7 +99,7 @@ QRectF AbstractChartLayout2::calculateContentMinimum(const QRectF &minimum) cons
 
 
 QRectF AbstractChartLayout2::calculateBackgroundGeometry(const QRectF &geometry,
-                                                        ChartBackground *background,
+                                                        ChartBackground2 *background,
                                                         bool update) const
 {
     qreal left;
@@ -107,8 +108,9 @@ QRectF AbstractChartLayout2::calculateBackgroundGeometry(const QRectF &geometry,
     qreal bottom;
     getContentsMargins(&left, &top, &right, &bottom);
     QRectF backgroundGeometry = geometry.adjusted(left, top, -right, -bottom);
-    if (background && update)
-        background->setRect(backgroundGeometry);
+    // TODO
+    //    if (background && update)
+//        background->setRect(backgroundGeometry);
     return backgroundGeometry;
 }
 
@@ -125,72 +127,72 @@ QRectF AbstractChartLayout2::calculateBackgroundMinimum(const QRectF &minimum) c
 QRectF AbstractChartLayout2::calculateLegendGeometry(const QRectF &geometry, QLegend2 *legend,
                                                     bool update) const
 {
-    QSizeF size = legend->effectiveSizeHint(Qt::PreferredSize, QSizeF(-1, -1));
+//    QSizeF size = legend->effectiveSizeHint(Qt::PreferredSize, QSizeF(-1, -1));
     QRectF legendRect;
     QRectF result;
 
-    switch (legend->alignment()) {
-    case Qt::AlignTop: {
-        legendRect = QRectF(geometry.topLeft(), QSizeF(geometry.width(), size.height()));
-        result = geometry.adjusted(0, legendRect.height(), 0, 0);
-        break;
-    }
-    case Qt::AlignBottom: {
-        legendRect = QRectF(QPointF(geometry.left(), geometry.bottom() - size.height()), QSizeF(geometry.width(), size.height()));
-        result = geometry.adjusted(0, 0, 0, -legendRect.height());
-        break;
-    }
-    case Qt::AlignLeft: {
-        qreal width = qMin(size.width(), geometry.width() * golden_ratio);
-        legendRect = QRectF(geometry.topLeft(), QSizeF(width, geometry.height()));
-        result = geometry.adjusted(width, 0, 0, 0);
-        break;
-    }
-    case Qt::AlignRight: {
-        qreal width = qMin(size.width(), geometry.width() * golden_ratio);
-        legendRect = QRectF(QPointF(geometry.right() - width, geometry.top()), QSizeF(width, geometry.height()));
-        result = geometry.adjusted(0, 0, -width, 0);
-        break;
-    }
-    default: {
-        legendRect = QRectF(0, 0, 0, 0);
-        result = geometry;
-        break;
-    }
-    }
-    if (update)
-        legend->setGeometry(legendRect);
+//    switch (legend->alignment()) {
+//    case Qt::AlignTop: {
+//        legendRect = QRectF(geometry.topLeft(), QSizeF(geometry.width(), size.height()));
+//        result = geometry.adjusted(0, legendRect.height(), 0, 0);
+//        break;
+//    }
+//    case Qt::AlignBottom: {
+//        legendRect = QRectF(QPointF(geometry.left(), geometry.bottom() - size.height()), QSizeF(geometry.width(), size.height()));
+//        result = geometry.adjusted(0, 0, 0, -legendRect.height());
+//        break;
+//    }
+//    case Qt::AlignLeft: {
+//        qreal width = qMin(size.width(), geometry.width() * golden_ratio);
+//        legendRect = QRectF(geometry.topLeft(), QSizeF(width, geometry.height()));
+//        result = geometry.adjusted(width, 0, 0, 0);
+//        break;
+//    }
+//    case Qt::AlignRight: {
+//        qreal width = qMin(size.width(), geometry.width() * golden_ratio);
+//        legendRect = QRectF(QPointF(geometry.right() - width, geometry.top()), QSizeF(width, geometry.height()));
+//        result = geometry.adjusted(0, 0, -width, 0);
+//        break;
+//    }
+//    default: {
+//        legendRect = QRectF(0, 0, 0, 0);
+//        result = geometry;
+//        break;
+//    }
+//    }
+//    if (update)
+//        legend->setGeometry(legendRect);
 
     return result;
 }
 
 QRectF AbstractChartLayout2::calculateLegendMinimum(const QRectF &geometry, QLegend2 *legend) const
 {
-    if (!legend->isAttachedToChart() || !legend->isVisible()) {
+//    if (!legend->isAttachedToChart() || !legend->isVisible()) {
         return geometry;
-    } else {
-        QSizeF minSize = legend->effectiveSizeHint(Qt::MinimumSize, QSizeF(-1, -1));
-        return geometry.adjusted(0, 0, minSize.width(), minSize.height());
-    }
+//    } else {
+//        QSizeF minSize = legend->effectiveSizeHint(Qt::MinimumSize, QSizeF(-1, -1));
+//        return geometry.adjusted(0, 0, minSize.width(), minSize.height());
+//    }
 }
 
-QRectF AbstractChartLayout2::calculateTitleGeometry(const QRectF &geometry, ChartTitle *title,
+QRectF AbstractChartLayout2::calculateTitleGeometry(const QRectF &geometry, ChartTitle2 *title,
                                                    bool update) const
 {
-    if (update)
-        title->setGeometry(geometry);
-    if (title->text().isEmpty()) {
+//    if (update)
+//        title->setGeometry(geometry);
+//    if (title->text().isEmpty()) {
         return geometry;
-    } else {
-        // Round to full pixel via QPoint to avoid one pixel clipping on the edge in some cases
-        QPointF center((geometry.center() - title->boundingRect().center()).toPoint());
-        if (update)
-            title->setPos(center.x(), title->pos().y());
-        return geometry.adjusted(0, title->boundingRect().height() + 1, 0, 0);
-    }
+//    } else {
+//        // Round to full pixel via QPoint to avoid one pixel clipping on the edge in some cases
+//        QPointF center((geometry.center() - title->boundingRect().center()).toPoint());
+//        if (update)
+//            title->setPos(center.x(), title->pos().y());
+//        return geometry.adjusted(0, title->boundingRect().height() + 1, 0, 0);
+//    }
 }
 
-QRectF AbstractChartLayout2::calculateTitleMinimum(const QRectF &minimum, ChartTitle *title) const
+QRectF AbstractChartLayout2::calculateTitleMinimum(const QRectF &minimum, ChartTitle2 *title) const
 {
     if (!title->isVisible() || title->text().isEmpty()) {
         return minimum;
@@ -205,7 +207,7 @@ QSizeF AbstractChartLayout2::sizeHint(Qt::SizeHint which, const QSizeF &constrai
     Q_UNUSED(constraint);
     if (which == Qt::MinimumSize) {
         QList<ChartAxisElement2 *> axes = m_presenter->axisItems();
-        ChartTitle *title = m_presenter->titleElement();
+        ChartTitle2 *title = m_presenter->titleElement();
         QLegend2 *legend = m_presenter->legend();
         QRectF minimumRect(0, 0, 0, 0);
         minimumRect = calculateBackgroundMinimum(minimumRect);
diff --git a/src/charts/layout/abstractchartlayout2_p.h b/src/charts/layout/abstractchartlayout2_p.h
index 3498f3c6..00385e60 100644
--- a/src/charts/layout/abstractchartlayout2_p.h
+++ b/src/charts/layout/abstractchartlayout2_p.h
@@ -46,11 +46,11 @@
 
 QT_CHARTS_BEGIN_NAMESPACE
 
-class ChartTitle;
+class ChartTitle2;
 class ChartAxisElement2;
 class ChartPresenter2;
 class QLegend2;
-class ChartBackground;
+class ChartBackground2;
 
 class QT_CHARTS_PRIVATE_EXPORT AbstractChartLayout2 : public QGraphicsLayout
 {
@@ -63,14 +63,14 @@ public:
     virtual void setGeometry(const QRectF &rect);
 
 protected:
-    virtual QRectF calculateBackgroundGeometry(const QRectF &geometry, ChartBackground *background,
+    virtual QRectF calculateBackgroundGeometry(const QRectF &geometry, ChartBackground2 *background,
                                                bool update = true) const;
     virtual QRectF calculateBackgroundMinimum(const QRectF &minimum) const;
     virtual QRectF calculateContentGeometry(const QRectF &geometry) const;
     virtual QRectF calculateContentMinimum(const QRectF &minimum) const;
-    virtual QRectF calculateTitleGeometry(const QRectF &geometry, ChartTitle *title,
+    virtual QRectF calculateTitleGeometry(const QRectF &geometry, ChartTitle2 *title,
                                           bool update = true) const;
-    virtual QRectF calculateTitleMinimum(const QRectF &minimum, ChartTitle *title) const;
+    virtual QRectF calculateTitleMinimum(const QRectF &minimum, ChartTitle2 *title) const;
     virtual QRectF calculateLegendGeometry(const QRectF &geometry, QLegend2 *legend,
                                            bool update = true) const;
     virtual QRectF calculateLegendMinimum(const QRectF &minimum, QLegend2 *legend) const;
